<!DOCTYPE html>
<html lang="en"> 
<head>
<title>Fusilli Technical Documentation</title>

<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<meta name="viewport" content="width=device-width, initial-scale=1.0">

<meta name="description" content="Fusilli Technical Documentation">
<link rel="shortcut icon" href="../favicon.png"> 
<link href="https://fonts.googleapis.com/css?family=Poppins:300,400,500,600,700&display=swap" rel="stylesheet">
<script defer src="../assets/fontawesome/js/all.min.js"></script>
	<link rel="stylesheet" href="http://cdnjs.cloudflare.com/ajax/libs/highlight.js/9.15.2/styles/atom-one-dark.min.css">
	<link id="theme-style" rel="stylesheet" href="../assets/css/theme.css">
</head> 

<body class="docs-page">    
<header class="header fixed-top" id="header">	    
 
</header>

<div class="docs-wrapper">
		<div id="docs-sidebar" class="docs-sidebar">
			
		</div>
		<div class="docs-content">
			<div class="container" id="container">
				<article class="docs-article" id="section-4">
					<header class="docs-header">
						<h1 class="docs-heading">Manager Admin Guide <span class="docs-time">Last updated: 2020-12-21</span></h1>
						<section class="docs-intro">
							<p>Explained below all the step and requirements needed to install and the ugprade the <b>fusilli.io-manager</b></p>
						</section>
					</header>
					<section class="docs-section" id="item-4-1">
						<h2 class="section-heading">Requirements</h2>
						<p>Listed below all the requirements to install the <b>fusilli.io-manager</b> through Helm and Kubernetes</p>
						<ul>
							<li>Kubernetes 1.14x</li>
							<li>Helm 3.x</li>
							<li>Kubectl v1.x.x</li>
						</ul>
					</section>
					<section class="docs-section" id="item-4-2">
						<h2 class="section-heading">Setup and Installation</h2>
							<p>This installation process is based on a Linux server running a Kubernetes cluster</p>
					<section class="docs-section-sub" id="item-4-2-1">
						<h3>Helm chart</h3>
						<p> Clone the Helm chart repository:</p>
						<pre><code> git clone https://gitlab.com/fusilli.io-manager-community/fusilli.io-manager-helm.git</code></pre>
						<p>For more info about the configuration needed for the chart check the <a href="https://gitlab.com/fusilli.io-manager-community/fusilli.io-manager-helm.git">readme</a> file in the repository</p>
					</section>
						<section class="docs-section-sub" id="item-4-2-2">
							<h3>Play Http Secret Key</h3>
						<p>In order to run the fusilli-manager you will need a <b>play.http.secret.key</b>, this key will be used as the key for ensuring that a Play session cookie is valid. So we will generate a new one for each installation.</p>
						<p>To do that we will run the following command:</p>
						<pre><code>head -c 32 /dev/urandom | base64</code></pre>
						<p>The command will generate a string of random characters of at least 32 bytes, after running the command you should receive in output something like this:</p>
						<pre><code>MkUZ0GgHXoW3hdg7SZ6huHEoX6MlnlbtIjtkXXLVh3E=</code></pre>
						<p>As we have generated the key we can now open the <b>config.yaml</b> file from the Helm package repository and in the field <b>stringData</b> we will put the key that we have generated earlier, it should look like this:</p>
						<pre><code>stringData: kUZ0GgHXoW3hdg7SZ6huHEoX6MlnlbtIjtkXXLVh3E=</code></pre>
						</section>
						<section class="docs-section-sub" id="item-4-2-3">
							<h3>Install</h3>
							<p>When each field of the config.yaml file is populated we can proceed with the installation process.</p>
							<p>Inside the cluster run the following command to install the <b>fusilli-manager</b>:</p>
							<pre><code>helm install fusilli-manager fusilli-manager-helm -f config.yml</code></pre>
							<p>To verify your installation do the following:</p>
							<p>Run the command below to inspect the list of all the application installed through Helm</p>
							<pre><code>helm list</code></pre>
							<p>Run the following command to inspect if there is any type of error on the pod created earlier</p>
							<pre><code>kubectl get pod</code></pre>
							<p>The chart will also create and bind a LoadBalancer to your pod, you can verify the external IP of the load balancer with the following command: </p>
							<pre><code>kubectl get svc</code></pre>
						</section>
					</section>
					
					<section class="docs-section" id="item-4-3">
						<h2 class="section-heading">Administration</h2>
						<p>The administrator of the install of <b>fusilli.io-manager</b> will be responsible of upgrading the version of the product in case of a new release, explained below the steps</p>
						<section class="docs-section-sub" id="item-4-3-1">
						<h3>Upgrade</h3>
						<p>In order to upgrade the installation of fusilli.io-manager the administrator will retrieve the new reference of the image and modify the <b>config.yaml</b> file.</p>
						<p>Then execute the following command to upgrade the installation:</p>
							<pre><code>helm upgrade fusilli-manager fusilli-manager -f config.yaml</code></pre>
						<p>Shown below the diagram that explain how <b>Kubernetes</b> works alongside the fusilli.io-manager:</p>
						<img src="./diagrams/fusilli-kube.PNG">
						</section>
					</section>

					<section class="docs-section" id="item-4-4">
						<h1 class="section-heading">Data Connectors</h1>
						<p>In order to communicate with different types of system fusilli.io uses different types of
										connectors.</p>
									<p>Said connector will allow you to choose from which system you will get and write your data.
									</p>
								</section>
			
								<section class="docs-section-sub" id="item-4-4-1">
									<h3>Files</h3>
									<p>With this connector the fusilli.io manager allows you to use data from a single file, as an
										example we can connect to an <b>SFTP</b> server and extract a specific to use as a source
										of data.</p>
								</section>
			
								<section class="docs-section-sub" id="item-4-4-2">
									<h3>JDBC</h3>
									<p>With the JDBC connector you can connect and use the data of any database that support the JDBC connection such as
										<b>PostgreSQL</b> or <b>Oracle</b></p>
								</section>
			
								<section class="docs-section-sub" id="item-4-4-3">
									<h3>Events</h3>
									<p>The Events connector allows you to use the event coming from a queue or a stream as a data
										source, as an example data coming from <b>Rabbit</b> or <b>Kafka</b></p>
								</section>
			
								<section class="docs-section-sub" id="item-4-4-4">
									<h3>HTTP</h3>
									<p>HTTP connector allow you to communicate with any <b>API</b> to send or receive data from it.
									</p>
					  </section>


					  <section class="docs-section" id="item-4-5">
						<h1 class="section-heading">Transformation Jobs</h1>
						<ul>
						  <li>Concatenate.</li>
						  <li>Split.</li>
						  <li>Rename.</li>
						  <li>Replace.</li>
						  <li>Mockinbird</li>
						  <li>Fork. </li>
						  <li>Join.</li>
						  <li>Matcher.</li>
						  <li>Math.</li>
						  <li>Marker</li>
						  <li>Stacker</li>
						  <li>SplitCloner</li>
						</ul>
						
					  <h3>Concatenate</h3>
					  <p><b>Functional description:</b> Job that concatenates two fields.</p>
						<p>Mandatory values ​​for correct configuration of the <b>job_configs</b> object are:</p>
						<ul>
										<li>"inputs_attrs": attributes to which the concat operation must be performed</li>
						  <li>"outputs_attrs": attribute to which the concat operation was performed</li>
						  <li>“config”.”spacing”: chaining character for attributes</li>
						</ul>
						  <p><b>JSON Input</b></p>
						  <pre>
							<code>
	{
		"jobs": [
		{
			"job_configuration_id":0,
			"job_id": 6,
			"job_name": "concat",
			"input_edges": [1],
			"output_edges": [2],
			"job_configs": [
			{
				"input_attrs": [
				"PROVINCIA","COMUNE"
				],
				"output_attrs": [
				"RESIDENZA"
				],
				"config": {
				"spacing": " - "
				}
			}
			]
		}
		]
	}
							
							</code>
						  </pre>
			
						  <h3>Split</h3>
					  <p><b>Functional description:</b> Job that split one field.</p>
						<p>Mandatory values ​​for correct configuration of the <b>job_configs</b> object are:</p>
						<ul>
										<li>"inputs_attrs": attribute that must be splitted</li>
						  <li>"outputs_attrs": attributes which have been splitted</li>
						  <li>“config”.”spacing”: chaining split character for attributes</li>
						</ul>
						  <p><b>JSON Input</b></p>
						  <pre>
							<code>
	{
		"jobs": [
		{
		"job_configuration_id":1,
		"job_id": 6,
		"job_name": "split",
		"input_edges": [1],
		"output_edges": [2],
		"job_configs": [
			{
			"input_attrs": [
			"DESCRIZIONE_INTERVENTO"
			],
			"output_attrs": [
				"INIZIO_INTERVENTO",
				"FINE_INTERVENTO"
			],
			"config": {
				"spacing": "-"
			}
			}
		]
		}
	]
	}
							</code>
						  </pre>
			
			
						  <h3>Rename</h3>
						  <p><b>Functional description:</b> Job that rename one field.</p>
							<p>Mandatory values ​​for correct configuration of the <b>job_configs</b> object are:</p>
							<ul>
							  <li>"inputs_attrs": attribute that must be renamed</li>
							  <li>"outputs_attrs": attribute which have been renamed</li>
							</ul>
							  <p><b>JSON Input</b></p>
							  <pre>
								<code>
	{
	"jobs": [
	{
		"job_configuration_id":1,
		"job_id": 1,
		"job_name": "rename",
		"input_edges": [1],
		"output_edges": [2],
		"job_configs": [
		{
			"input_attrs": [
			"PROPRIETARIO_FO"
			],
			"output_attrs": [
			"POSSESSORE_FO"
			],
			"config": {
			}
		}
		]
	}
	]
}
								
								</code>
							  </pre>
			
							  <h3>Replace</h3>
						  <p><b>Functional description:</b> Job that replace on character in one field.</p>
							<p>Mandatory values ​​for correct configuration of the <b>job_configs</b> object are:</p>
							<ul>
							  <li>"inputs_attrs": attribute that must be replaced</li>
							  <li>"outputs_attrs": attributes which have been replaced</li>
							  <li>“config”.”replaced”:character to substitute for attributes</li>
							  <li>“config”.”replacer”: substituent character for attributes</li>
							</ul>
							  <p><b>JSON Input</b></p>
							  <pre>
								<code>
	{
	"jobs": [
		{
			"job_configuration_id": 0,
			"job_id": 6,
			"job_name": "replace",
			"input_edges": [
				1
			],
			"output_edges": [
				2
			],
			"job_configs": [
				{
					"input_attrs": [
						"DESCRIZIONE_INTERVENTO"
					],
					"output_attrs": [
						"DESCRIZIONE_INTERVENTO"
					],
					"config": {
						"replaced": "-",
						"replacer": "/"
					}
				}
			]
		}
	]
}
								</code>
							  </pre>
			
							  <h3>Mockinbird</h3>
						  <p><b>Functional description:</b> Job that populates one field.</p>
							  <p><b>JSON Input</b></p>
							  <pre>
								<code>
	{
	"jobs": [
	{
		"job_configuration_id":0,
		"job_id": 6,
		"job_name": "id",
		"input_edges": [1],
		"output_edges": [2],
		"job_configs": []
	}
	]
}                    
								</code>
							  </pre>
			
							  <h3>Fork</h3>
							  <p><b>JSON Input</b></p>
							  <pre>
								<code>
		{
		"jobs":[
			{
				"job_id":1,
				"job_name":"fork",
				"input_edges":[1],
				"output_edges":[2,3],
				"job_configs":[
					{
						"input_attrs":[],
						"output_attrs":[
							"INIZIO_INTERVENTO",
							"FINE_INTERVENTO"
						],
						"config":{
							"edge":"2"
						}
					},
					{
						"input_attrs":[],
						"output_attrs":[
							"COMUNE",
							"PROVINCIA"
						],
						"config":{
							"edge":"3"
						}
					}
				]
			}
		]
	}                                        
								</code>
							  </pre>
			
							  <h3>Join</h3>
							  <p><b>JSON Input</b></p>
							  <pre>
								<code>
	{
	"jobs": [
		{
		"job_id": 1,
		"job_name": "join",
		"input_edges": [
			1
		],
		"output_edges": [
			2
		],
		"job_configs": [
			{
			"input_attrs": [],
			"output_attrs": [],
			"config": {
				"secondary_input": {
				"source_id": 1,
				"repo_name": "fusilli ftp",
				"repo_user": "fusilli_ftp",
				"repo_password": "Fu51||1",
				"repo_type": "sftp",
				"host": "localhost",
				"port": 22,
				"schema_path": "download/test-file/",
				"entities": [
					{
					"entity_id": 10,
					"connection_edge": 1,
					"entity_name": "collegamentiinfibraottica2017.csv",
					"entity_type": "csv",
					"separator": ";",
					"attributes": [
						{
						"attr_name": "PROVINCIA",
						"attr_type": "VARCHAR(50)",
						"format": "",
						"length": ""
						},
						{
						"attr_name": "COMUNE",
						"attr_type": "VARCHAR(50)",
						"format": "",
						"length": ""
						},
						{
						"attr_name": "CODICE_INTERVENTO",
						"attr_type": "VARCHAR(50)",
						"format": "",
						"length": ""
						},
						{
						"attr_name": "DESCRIZIONE_INTERVENTO",
						"attr_type": "VARCHAR(50)",
						"format": "",
						"length": ""
						},
						{
						"attr_name": "LUNGHEZZA_TRATTA_FO",
						"attr_type": "INTEGER",
						"format": "",
						"length": ""
						},
						{
						"attr_name": "PROPRIETARIO_FO",
						"attr_type": "VARCHAR(50)",
						"format": "",
						"length": ""
						}
					]
					}
				]
				},
				"matching_fields": [
				{
					"match_condition": "equals",
					"first_one": "String",
					"second_one": "String"
				},
				{
					"match_condition": "equals",
					"first_one": "String",
					"second_one": "String"
				}
				]
			}
			}
		]
		}
	]
	}
																		  
								</code>
							  </pre>
			
							  <h3>Matcher</h3>
							  <p><b>JSON Input</b></p>
							  <pre>
								<code>
		{            
		"job_configuration_id": 1,            
		"job_id": 1,            
		"job_name": "match",            
		"input_edges": [ 11 ],            
		"output_edges": [ 84,85 ],  
		"job_configs":[
						{
							"input_attrs":[],
							"output_attrs":[],
							"config":[{
								"fun":"NAND",
								"apply_to":
									[{
									"verify": "equals",
									"key": "COLORE",
									"value": "Blu",
									"cond_type": "string"
									},
									{
									"verify": "equals",
									"key": "FORMA",
									"value": "Ics",
									"cond_type": "string"
									}]
						}]
					}
				]
		}
								</code>
							  </pre>
			
							  <h3>Math</h3>
							  <p><b>JSON Input</b></p>
							  <pre>
								<code>
			{
			"jobs":[
				{
					"job_id":1,
					"job_name":"math",
					"input_edges":[
						1
					],
					"output_edges":[
						2
					],
					"job_configs":[
						{
							"input_attrs":[
								"CODICE_INTERVENTO",
								"COMUNE",
								"PROVINCIA"
							],
							"output_attrs":[
								"CALCOLO"
							],
							"config":{
								"operation":"+"
							}
						}
					]
				}
			]
		}                                                                                 
								</code>
							  </pre>
			
			
					  </section>
				</article>

				<footer class="footer">
					<div class="container text-center py-5">
						<ul class="social-list list-unstyled pt-4 mb-0">
							<li class="list-inline-item"><a href="#"><i class="fab fa-github fa-fw"></i></a></li> 
							<li class="list-inline-item"><a href="#"><i class="fab fa-twitter fa-fw"></i></a></li>
							<li class="list-inline-item"><a href="#"><i class="fab fa-slack fa-fw"></i></a></li>
							<li class="list-inline-item"><a href="#"><i class="fab fa-product-hunt fa-fw"></i></a></li>
							<li class="list-inline-item"><a href="#"><i class="fab fa-facebook-f fa-fw"></i></a></li>
							<li class="list-inline-item"><a href="#"><i class="fab fa-instagram fa-fw"></i></a></li>
						</ul>
					</div>
				</footer>
			</div> 
		</div>
</div>

<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script src="../assets/plugins/popper.min.js"></script>
<script src="../assets/plugins/bootstrap/js/bootstrap.min.js"></script>  

<script src="https://cdnjs.cloudflare.com/ajax/libs/highlight.js/9.15.8/highlight.min.js"></script>
<script src="../assets/js/highlight-custom.js"></script> 
<script src="../assets/plugins/jquery.scrollTo.min.js"></script>
<script src="../assets/plugins/lightbox/dist/ekko-lightbox.min.js"></script> 
	<script src="../assets/js/docs.js"></script>
	
	<script>
		$(document).ready(function () {
			const params = new URLSearchParams(window.location.search)
			if (params.has('search')) {
				var searchbox = document.getElementById('search');
				searchbox.value = params.get('search');
			};
		});

		function searchDoc() {
			//alert($("#search-warn").is(":visible"));
			if ($("#search-warn").is(":visible")) {
				$("#search-warn").toggle();
			};

			var minLength = 3;
			var searchVal = $(document.getElementById('search')).val().trim().toLowerCase();
			//alert(searchVal.length < minLength);
			if (searchVal.length < minLength) {
				$("#search-warn").toggle();
			} else {
				$("#container *").filter(function() {
					//alert($(this).text().toLowerCase().indexOf(value));
					//$(this).toggle($(this).text().toLowerCase().indexOf(value) > -1)
					//alert($(this).text());
				});
			}
			return false;
		};
	</script>

<!-- Start: Global site tag (gtag.js) - Google Analytics -->
<script async src="https://www.googletagmanager.com/gtag/js?id=UA-179633743-1"></script>
<script>
  window.dataLayer = window.dataLayer || [];
  function gtag(){dataLayer.push(arguments);}
  gtag('js', new Date());

  gtag('config', 'UA-179633743-1');
</script>

<!-- End: Global site tag (gtag.js) - Google Analytics  -->

</body>
</html> 

